SystemOrganization addCategory: #ConfigurationOfOPAX!

Object subclass: #ConfigurationOfOPAX
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfOPAX'!

!ConfigurationOfOPAX commentStamp: '<historical>' prior: 0!
(ConfigurationOfOPAX project version: #stable) load: 'Tests'!

!ConfigurationOfOPAX class methodsFor: 'development support' stamp: 'StephaneDucasse 3/3/2013 17:11'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfOPAX class methodsFor: 'private' stamp: 'StephaneDucasse 3/3/2013 17:11'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfOPAX class methodsFor: 'private' stamp: 'StephaneDucasse 3/3/2013 17:11'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfOPAX class methodsFor: 'private' stamp: 'StephaneDucasse 3/3/2013 17:11'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfOPAX class methodsFor: 'metacello tool support' stamp: 'StephaneDucasse 3/3/2013 17:11'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfOPAX class methodsFor: 'loading' stamp: 'StephaneDucasse 3/3/2013 17:11'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfOPAX class methodsFor: 'loading' stamp: 'StephaneDucasse 3/3/2013 17:11'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfOPAX class methodsFor: 'loading' stamp: 'StephaneDucasse 3/3/2013 17:11'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfOPAX class methodsFor: 'accessing' stamp: 'StephaneDucasse 3/3/2013 17:11'!
project

	^self new project! !

!ConfigurationOfOPAX class methodsFor: 'development support' stamp: 'StephaneDucasse 3/3/2013 17:11'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfOPAX methodsFor: 'baselines' stamp: 'StephaneDucasse 3/12/2013 22:08'!
baseline10: spec
	<version: '1.0-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec description: 'Migrated from Squeaksource, added a configuration and two packages'.
		spec repository: 'http://smalltalkhub.com/mc/PharoExtras/OPAX/main'.
	
	"depending on XMLParser"
	spec project: 'XMLParser'
					with: [ spec 
								className: 'ConfigurationOfXMLParser';
								versionString: #stable;
								repository: 'http://www.smalltalkhub.com/mc/PharoExtras/XMLParser/main'.].
							
	"Now we express the dependency at the package level"
	
	spec package: 'Opax-Base' with: [spec requires: 'XMLParser'].		
	spec package: 'Opax-Tests' with: [ spec requires: 'Opax-Base' ].
	spec group: 'default' with: #('Core' 'Tests').
	"default by default is equivalent to loading 'ALL' the packages still we added explicitly Tests to be loaded"
	spec group: 'Core' with: #('Opax-Base' ).
	spec group: 'Tests' with: #('Opax-Tests' )
	].
! !

!ConfigurationOfOPAX methodsFor: 'symbolic versions' stamp: 'StephaneDucasse 3/3/2013 17:13'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '1.0'.
! !

!ConfigurationOfOPAX methodsFor: 'accessing' stamp: 'StephaneDucasse 3/3/2013 17:11'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfOPAX methodsFor: 'symbolic versions' stamp: 'StephaneDucasse 3/3/2013 17:13'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '1.0'.
! !

!ConfigurationOfOPAX methodsFor: 'versions' stamp: 'StephaneDucasse 3/3/2013 17:27'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'release'.
		spec description: 'First version migrated and configured with two packages'.
		spec author: 'StephaneDucasse'.
		spec timestamp: '03/03/2013 16:43'.
		spec package: 'Opax-Base' with: 'Opax-Base-StephaneDucasse.2'. 
		spec package: 'Opax-Tests' with: 'Opax-Tests-StephaneDucasse.3'. ].
! !
